#include <iostream>

#include "array.hpp"

int main()
{
    size_t len = 1000;
    Array<int> a(len, 3);

    counter = 0;
    auto t0 = std::chrono::high_resolution_clock::now();
    for (size_t i=0; i<1e4; ++i) {
        auto d = a+a+a+a+a+a+a+a+a+a+a+a+a+a+a+a+a;
        //       \_______________  ______________/
        //                       \/   
        //         17 addendi = 16 somme (di cui 15 con lvalue)
    }
    auto t1 = std::chrono::high_resolution_clock::now();
    auto elapsed = std::chrono::duration_cast<std::chrono::milliseconds>(t1 - t0);
    std::cout << "Execution time " 
#ifdef MOVE_ON
              << "(move semantics): " 
#else // MOVE_ON
              << "(no move semantics): " 
#endif // MOVE_ON
              << elapsed.count() << " milliseconds"
              << std::endl;
    std::cout << "Somme con move semantics: " << counter << std::endl;
    return 0;
}